package com.gic.demo.single;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.ResultSetInternalMethods;
import com.mysql.jdbc.Statement;
import com.mysql.jdbc.StatementInterceptorV2;

import java.sql.SQLException;
import java.util.Properties;

/**
 * @author zhurz
 */
public class MySQLTestIntercepter implements StatementInterceptorV2 {

    private void println(String method, String argName, Object argVal) {
        System.out.println(String.format("%s -> %s %s:%s", Thread.currentThread(), method, argName, argVal));
    }

    @Override
    public void init(Connection conn, Properties props) throws SQLException {
//        println("init", "conn", conn);
//        println("init", "props", props);
    }

    @Override
    public ResultSetInternalMethods preProcess(String sql, Statement interceptedStatement, Connection connection) throws SQLException {
//        println("preProcess", "sql", sql);
//        println("preProcess", "interceptedStatement", interceptedStatement);
//        println("preProcess", "isReadOnly", connection.isReadOnly());
        return null;
    }

    @Override
    public boolean executeTopLevelOnly() {
        return false;
    }

    @Override
    public void destroy() {

    }

    @Override
    public ResultSetInternalMethods postProcess(
            String sql, Statement interceptedStatement, ResultSetInternalMethods originalResultSet, Connection connection,
            int warningCount, boolean noIndexUsed, boolean noGoodIndexUsed, SQLException statementException) throws SQLException {
//        println("postProcess", "sql", sql);
//        println("postProcess", "interceptedStatement", interceptedStatement);
//        println("postProcess", "isReadOnly", connection.isReadOnly());
        return null;
    }
}
